import { Box, Modal } from "@mui/material";
import React from "react";

var HotkeysModal = function HotkeysModal(_ref) {
  var openHotkeyModal = _ref.openHotkeyModal,
      setOpenHotkeyModal = _ref.setOpenHotkeyModal;
  var style = {
    position: "absolute",
    top: "50%",
    left: "50%",
    transform: "translate(-50%, -50%)",
    width: 500,
    bgcolor: "background.paper",
    boxShadow: 24,
    p: 2,
    maxHeight: "80vh",
    overflow: "auto"
  };
  var shortcuts = [{
    shortcut: ["x"],
    description: "Complete polygon or polyline"
  }, {
    shortcut: ["c"],
    description: "Cancel"
  }, {
    shortcut: ["r"],
    description: "Reset zoom scale"
  }, {
    shortcut: ["→"],
    description: "Next image"
  }, {
    shortcut: ["←"],
    description: "Prev image"
  }, {
    shortcut: ["esc"],
    description: "Exit fullscreen"
  }, {
    shortcut: ["ctrl", "enter"],
    description: "Save"
  }, {
    shortcut: ["ctrl", "z"],
    description: "Undo"
  }];
  return React.createElement(Modal, {
    container: document.querySelector(".fullscreen"),
    open: openHotkeyModal,
    onClose: function onClose() {
      return setOpenHotkeyModal(false);
    }
  }, React.createElement(Box, {
    sx: style
  }, React.createElement(Box, {
    component: "table",
    sx: {
      width: "100%",
      fontSize: "14px"
    }
  }, React.createElement(Box, {
    component: "thead",
    sx: {
      bgcolor: "#fafafa",
      width: "100%",
      fontWeight: 500,
      "& tr": {
        textAlign: "left"
      },
      "& th": {
        padding: "8px",
        borderBottom: "1px solid #f0f0f0"
      }
    }
  }, React.createElement("tr", null, React.createElement("th", null, "Shortcuts"), React.createElement("th", null, "Description"))), React.createElement(Box, {
    component: "tbody"
  }, shortcuts.map(function (shortcut, i) {
    return React.createElement(Box, {
      component: "tr",
      sx: {
        borderBottom: "1px solid #f0f0f0",
        cursor: "default",
        "&:hover": {
          bgcolor: "#fafafa"
        },
        "& td": {
          padding: "10px"
        }
      },
      key: i
    }, React.createElement(Box, {
      component: "td"
    }, shortcut.shortcut.map(function (hotkey, i) {
      return React.createElement("kbd", {
        style: {
          borderRadius: "2px",
          boxShadow: "0 0 0 1px rgba(0, 0, 0, 0.1), 0 1px 0 rgba(0, 0, 0, 0.08)",
          fontSize: "12px",
          fontWeight: 700,
          height: "16px",
          padding: "0px 4px",
          textTransform: "uppercase"
        },
        key: i
      }, hotkey);
    })), React.createElement("td", {
      style: {
        fontWeight: 300
      }
    }, shortcut.description));
  })))));
};

export default HotkeysModal;