import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React, { useCallback, useRef, useState } from "react";
import { makeStyles } from "@mui/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import { styled } from "@mui/material/styles";
import DebugBox from "../DebugSidebarBox";
import ImageCanvas from "../ImageCanvas";
import KeyframeTimeline from "../KeyframeTimeline";
import KeyframesSelector from "../KeyframesSelectorSidebarBox";
import RegionSelector from "../RegionSelectorSidebarBox";
import SettingsDialog from "../SettingsDialog";
import Workspace from "../WorkspaceLayout/Workspace";
import classnames from "classnames";
import getActiveImage from "../Annotator/reducers/get-active-image";
import getHotkeyHelpText from "../utils/get-hotkey-help-text";
import iconDictionary from "./icon-dictionary";
import styles from "./styles";
import { useDispatchHotkeyHandlers } from "../ShortcutsManager";
import useEventCallback from "use-event-callback";
import useImpliedVideoRegions from "./use-implied-video-regions";
import useKey from "use-key-hook";
import { useSettings } from "../SettingsProvider";
import { withHotKeys } from "react-hotkeys";
import Header from "../Header";
import PolylineIcon from "@mui/icons-material/Polyline";
import useShiftKey from "../hooks/useShiftKey";
import HotkeysModal from "../HotkeysModal";
import MagicalStaffIcon from "@mui/icons-material/AutoFixHigh";
import LinearScaleIcon from "@mui/icons-material/LinearScale";
import TagIcon from "@mui/icons-material/LocalOffer";
import QuestionAnswerIcon from "@mui/icons-material/QuestionAnswer";
import useCtrlKey from "../hooks/useCtrlKey";
import MetaTagsModal from "../MetaTagsModal"; // import Fullscreen from "../Fullscreen"

var emptyArr = [];
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
var HotkeyDiv = withHotKeys(function (_ref) {
  var hotKeys = _ref.hotKeys,
      children = _ref.children,
      divRef = _ref.divRef,
      props = _objectWithoutProperties(_ref, ["hotKeys", "children", "divRef"]);

  return React.createElement("div", Object.assign({}, _objectSpread({}, hotKeys, props), {
    ref: divRef
  }), children);
}); // eslint-disable-next-line

var FullScreenContainer = styled("div")(function (_ref2) {
  var theme = _ref2.theme;
  return {
    width: "100%",
    height: "100%",
    "& .fullscreen": {
      width: "100%",
      height: "100%"
    }
  };
});
export var MainLayout = function MainLayout(_ref3) {
  var _state$images$state$s, _state$images$state$s2;

  var hideImagesTab = _ref3.hideImagesTab,
      isVideo = _ref3.isVideo,
      isReviewer = _ref3.isReviewer,
      state = _ref3.state,
      dispatch = _ref3.dispatch,
      dispatchToReducer = _ref3.dispatchToReducer,
      _ref3$alwaysShowNextB = _ref3.alwaysShowNextButton,
      alwaysShowNextButton = _ref3$alwaysShowNextB === void 0 ? false : _ref3$alwaysShowNextB,
      _ref3$alwaysShowPrevB = _ref3.alwaysShowPrevButton,
      alwaysShowPrevButton = _ref3$alwaysShowPrevB === void 0 ? false : _ref3$alwaysShowPrevB,
      RegionEditLabel = _ref3.RegionEditLabel,
      onRegionClassAdded = _ref3.onRegionClassAdded,
      hideHeader = _ref3.hideHeader,
      hideHeaderText = _ref3.hideHeaderText,
      _ref3$hideNext = _ref3.hideNext,
      hideNext = _ref3$hideNext === void 0 ? false : _ref3$hideNext,
      _ref3$hidePrev = _ref3.hidePrev,
      hidePrev = _ref3$hidePrev === void 0 ? false : _ref3$hidePrev,
      _ref3$hideClone = _ref3.hideClone,
      hideClone = _ref3$hideClone === void 0 ? false : _ref3$hideClone,
      _ref3$hideSettings = _ref3.hideSettings,
      hideSettings = _ref3$hideSettings === void 0 ? false : _ref3$hideSettings,
      _ref3$hideFullScreen = _ref3.hideFullScreen,
      hideFullScreen = _ref3$hideFullScreen === void 0 ? false : _ref3$hideFullScreen,
      _ref3$hideSave = _ref3.hideSave,
      hideSave = _ref3$hideSave === void 0 ? false : _ref3$hideSave,
      onExit = _ref3.onExit,
      onUploadImage = _ref3.onUploadImage,
      onClickPDF = _ref3.onClickPDF,
      onClickLoadMore = _ref3.onClickLoadMore,
      onAIPoint = _ref3.onAIPoint,
      headerButtons = _ref3.headerButtons,
      fullScreenHandle = _ref3.fullScreenHandle,
      onChangeLabels = _ref3.onChangeLabels,
      onNext = _ref3.onNext,
      onPrev = _ref3.onPrev;
  var classes = useStyles();
  var settings = useSettings(); // const fullScreenHandle = useFullScreenHandle()

  var memoizedActionFns = useRef({});

  var action = function action(type) {
    for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      params[_key - 1] = arguments[_key];
    }

    var fnKey = "".concat(type, "(").concat(params.join(","), ")");
    if (memoizedActionFns.current[fnKey]) return memoizedActionFns.current[fnKey];

    var fn = function fn() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return params.length > 0 ? dispatch(_objectSpread({
        type: type
      }, params.reduce(function (acc, p, i) {
        return acc[p] = args[i], acc;
      }, {}))) : dispatch(_objectSpread({
        type: type
      }, args[0]));
    };

    memoizedActionFns.current[fnKey] = fn;
    return fn;
  };

  var _getActiveImage = getActiveImage(state),
      currentImageIndex = _getActiveImage.currentImageIndex,
      activeImage = _getActiveImage.activeImage;

  var nextImage;

  if (currentImageIndex !== null) {
    nextImage = state.images[currentImageIndex + 1];
  }

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      openSubClassMenu = _useState2[0],
      setOpenSubClassMenu = _useState2[1];

  var keyEventDisabled = ((_state$images$state$s = state.images[state.selectedImage]) === null || _state$images$state$s === void 0 ? void 0 : (_state$images$state$s2 = _state$images$state$s.regions) === null || _state$images$state$s2 === void 0 ? void 0 : _state$images$state$s2.find(function (r) {
    return r.editingLabels;
  })) || openSubClassMenu;
  useKey(function (key, event) {
    switch (key) {
      case 32: // SPACE

      case 13:
        // Enter
        if (event.ctrlKey && [13].includes(key)) {
          fullScreenHandle.exit();
          onExit(_objectSpread({}, state, {
            images: state.images.slice(0, state.images.length - 1)
          }));
          break;
        }

        dispatchToReducer({
          type: "HANDLE_PREVENT",
          event: event
        });
        break;

      case 120: // X

      case 88:
        // x
        if (keyEventDisabled) return key;
        dispatchToReducer({
          type: "FINISH_POLYLINE"
        });
        dispatchToReducer({
          type: "FINISH_POLYGON"
        });
        dispatchToReducer({
          type: "FINISH_POLYLINE_BS"
        });
        dispatchToReducer({
          type: "FINISH_AI"
        });
        break;
      // case 27: // ESC

      case 67: // C

      case 99:
        // c
        if (keyEventDisabled) return key;
        dispatch({
          type: "CANCEL"
        });
        break;

      case 90:
      case 122:
        event.ctrlKey && [90, 122].includes(key) && action("RESTORE_HISTORY")();
        break;
      // eslint-disable-next-line

      default:
        // console.log(key)
        break;
    }
  }, {
    detectKeys: [13, 27, 120, 88, 90, 122, 32, 13, 67, 99]
  }, {
    dependencies: [keyEventDisabled]
  });

  var _useShiftKey = useShiftKey(),
      isShiftDown = _useShiftKey.isShiftDown;

  var _useCtrlKey = useCtrlKey(),
      isCtrlDown = _useCtrlKey.isCtrlDown; // eslint-disable-next-line


  var isAVideoFrame = activeImage && activeImage.frameTime !== undefined;
  var innerContainerRef = useRef();
  var hotkeyHandlers = useDispatchHotkeyHandlers({
    dispatch: dispatch
  });
  var impliedVideoRegions = useImpliedVideoRegions(state);
  var refocusOnMouseEvent = useCallback(function (e) {
    if (!innerContainerRef.current) return;
    if (innerContainerRef.current.contains(document.activeElement)) return;

    if (innerContainerRef.current.contains(e.target)) {
      innerContainerRef.current.focus();
      e.target.focus();
    }
  }, []);
  var canvas = React.createElement(ImageCanvas, Object.assign({}, settings, {
    state: state,
    keyEventDisabled: keyEventDisabled,
    openSubClassMenu: openSubClassMenu,
    setOpenSubClassMenu: setOpenSubClassMenu,
    isShiftDown: isShiftDown,
    isCtrlDown: isCtrlDown,
    showCrosshairs: settings.showCrosshairs && !["select", "pan", "zoom"].includes(state.selectedTool),
    key: state.selectedImage,
    showMask: state.showMask,
    fullImageSegmentationMode: state.fullImageSegmentationMode,
    autoSegmentationOptions: state.autoSegmentationOptions,
    showTags: state.showTags,
    allowedArea: state.allowedArea,
    modifyingAllowedArea: state.selectedTool === "modify-allowed-area",
    regionClsList: state.regionClsList,
    pointClsList: state.pointClsList,
    regionTagList: state.regionTagList,
    pointTagList: state.pointTagList,
    regions: state.annotationType === "image" ? activeImage.regions || [] : impliedVideoRegions,
    dispatch: dispatchToReducer,
    realSize: activeImage ? activeImage.realSize : undefined,
    videoPlaying: state.videoPlaying,
    imageSrc: state.annotationType === "image" ? activeImage.src : null,
    videoSrc: state.annotationType === "video" ? state.videoSrc : null,
    pointDistancePrecision: state.pointDistancePrecision,
    createWithPrimary: state.selectedTool.includes("create"),
    dragWithPrimary: state.selectedTool === "pan",
    zoomWithPrimary: state.selectedTool === "zoom",
    showPointDistances: state.showPointDistances,
    videoTime: state.annotationType === "image" ? state.selectedImageFrameTime : state.currentVideoTime,
    keypointDefinitions: state.keypointDefinitions,
    onMouseMove: action("MOUSE_MOVE"),
    onMouseDown: function onMouseDown(params) {
      dispatchToReducer(_objectSpread({
        type: "MOUSE_DOWN"
      }, params, {
        dispatch: dispatchToReducer
      }));
    },
    onMouseUp: action("MOUSE_UP"),
    onMouseRightDown: function onMouseRightDown(params) {
      dispatchToReducer(_objectSpread({
        type: "MOUSE_RIGHT_DOWN"
      }, params, {
        dispatch: dispatchToReducer
      }));
    },
    onChangeRegion: action("CHANGE_REGION", "region"),
    onBeginRegionEdit: action("OPEN_REGION_EDITOR", "region"),
    onCloseRegionEdit: action("CLOSE_REGION_EDITOR", "region"),
    onDeleteRegion: action("DELETE_REGION", "region"),
    onBeginBoxTransform: action("BEGIN_BOX_TRANSFORM", "box", "directions"),
    onBeginMovePolygonPoint: action("BEGIN_MOVE_POLYGON_POINT", "polygon", "pointIndex"),
    onBeginMoveKeypoint: action("BEGIN_MOVE_KEYPOINT", "region", "keypointId"),
    onAddPolygonPoint: action("ADD_POLYGON_POINT", "polygon", "point", "pointIndex"),
    onSelectRegion: action("SELECT_REGION", "region"),
    onBeginMovePoint: action("BEGIN_MOVE_POINT", "point"),
    onImageLoaded: action("IMAGE_LOADED", "image"),
    RegionEditLabel: RegionEditLabel,
    onImageOrVideoLoaded: action("IMAGE_OR_VIDEO_LOADED", "metadata"),
    onChangeVideoTime: action("CHANGE_VIDEO_TIME", "newTime"),
    onChangeVideoPlaying: action("CHANGE_VIDEO_PLAYING", "isPlaying"),
    onRegionClassAdded: onRegionClassAdded,
    allowComments: state.allowComments
  }));

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      openImageTags = _useState4[0],
      setOpenImageTags = _useState4[1];

  var onClickIconSidebarItem = useEventCallback(function (item) {
    if (item.name === "open-image-tags") {
      setOpenImageTags(function (prev) {
        return !prev;
      });
    }

    dispatch({
      type: "SELECT_TOOL",
      selectedTool: item.name
    });
  });
  var onClickHeaderItem = useEventCallback(function (item) {
    if (item.name === "Fullscreen") {
      fullScreenHandle.enter();
    } else if (item.name === "Window") {
      fullScreenHandle.exit();
    }

    dispatch({
      type: "HEADER_BUTTON_CLICKED",
      buttonName: item.name
    });
  });
  var debugModeOn = Boolean(window.localStorage.$ANNOTATE_DEBUG_MODE && state);
  var nextImageHasRegions = !nextImage || nextImage.regions && nextImage.regions.length > 0;

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      openHotkeyModal = _useState6[0],
      setOpenHotkeyModal = _useState6[1];

  return React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement(HotkeyDiv // style={{padding: '20px'}}
  , {
    tabIndex: -1,
    divRef: innerContainerRef,
    onMouseDown: refocusOnMouseEvent,
    onMouseOver: refocusOnMouseEvent,
    allowChanges: true,
    handlers: hotkeyHandlers,
    className: classnames(classes.container, state.fullScreen && "Fullscreen")
  }, React.createElement(HotkeysModal, {
    openHotkeyModal: openHotkeyModal,
    setOpenHotkeyModal: setOpenHotkeyModal
  }), React.createElement(Header, {
    setOpenHotkeyModal: setOpenHotkeyModal,
    keyEventDisabled: keyEventDisabled,
    isVideo: isVideo,
    isReviewer: isReviewer,
    history: state.history,
    onRestoreHistory: action("RESTORE_HISTORY"),
    dispatch: dispatchToReducer,
    onExit: onExit,
    state: state,
    fullScreenHandle: fullScreenHandle,
    onUploadImage: onUploadImage,
    onClickPDF: onClickPDF,
    onClickLoadMore: onClickLoadMore,
    hideFullScreen: hideFullScreen,
    headerButtons: headerButtons,
    hideImagesTab: hideImagesTab,
    onNext: onNext,
    onPrev: onPrev
  }), React.createElement(MetaTagsModal, {
    state: state,
    dispatch: dispatchToReducer,
    openImageTags: openImageTags,
    setOpenImageTags: setOpenImageTags
  }), React.createElement(Workspace, {
    fullScreenHandle: fullScreenHandle,
    allowFullscreen: true,
    iconDictionary: iconDictionary // hideHeader={hideHeader}
    ,
    hideHeader: true,
    hideHeaderText: hideHeaderText,
    headerLeftSide: [state.annotationType === "video" ? React.createElement(KeyframeTimeline, {
      currentTime: state.currentVideoTime,
      duration: state.videoDuration,
      onChangeCurrentTime: action("CHANGE_VIDEO_TIME", "newTime"),
      keyframes: state.keyframes
    }) : activeImage ? React.createElement("div", {
      className: classes.headerTitle
    }, activeImage.name) : null].filter(Boolean),
    headerItems: [!hidePrev && {
      name: "Prev"
    }, !hideNext && {
      name: "Next"
    }, state.annotationType !== "video" ? null : !state.videoPlaying ? {
      name: "Play"
    } : {
      name: "Pause"
    }, !hideClone && !nextImageHasRegions && activeImage.regions && {
      name: "Clone"
    }, !hideSettings && {
      name: "Settings"
    }, !hideFullScreen && (state.fullScreen ? {
      name: "Window"
    } : {
      name: "Fullscreen"
    }), !hideSave && {
      name: "Save"
    }].filter(Boolean),
    onClickHeaderItem: onClickHeaderItem,
    onClickIconSidebarItem: onClickIconSidebarItem,
    selectedTools: [state.selectedTool, state.showTags && "show-tags", state.showMask && "show-mask"].filter(Boolean),
    iconSidebarItems: [{
      name: "select",
      helperText: "Select" + getHotkeyHelpText("select_tool"),
      alwaysShowing: true
    }, {
      name: "pan",
      helperText: "Drag/Pan (right or middle click)" + getHotkeyHelpText("pan_tool"),
      alwaysShowing: true
    }, {
      name: "zoom",
      helperText: "Zoom In/Out (scroll)" + getHotkeyHelpText("zoom_tool"),
      alwaysShowing: true
    }, // {
    //   name: "show-tags",
    //   helperText: "Show / Hide Tags",
    //   alwaysShowing: true,
    // },
    {
      name: "create-point",
      helperText: "Add Point" + getHotkeyHelpText("create_point")
    }, {
      name: "create-box",
      helperText: "Add Bounding Box" + getHotkeyHelpText("create_bounding_box")
    }, {
      name: "create-polygon",
      helperText: "Add Polygon" + getHotkeyHelpText("create_polygon")
    }, {
      name: "create-polyline",
      helperText: "Add Polyline",
      icon: React.createElement(PolylineIcon, null)
    }, {
      name: "create-polyline-bs",
      helperText: "Advanced Polyline",
      icon: React.createElement(LinearScaleIcon, null)
    }, {
      name: "open-image-tags",
      helperText: "Meta Tags",
      icon: React.createElement(TagIcon, null)
    }, {
      name: "create-reviewer-comment",
      helperText: "Add Reviewer Comment",
      icon: React.createElement(QuestionAnswerIcon, null)
    }, {
      name: "create-ai",
      helperText: "AI Tools",
      icon: React.createElement(MagicalStaffIcon, null)
    }, {
      name: "create-line",
      helperText: "Add Line"
    }, {
      name: "create-expanding-line",
      helperText: "Add Expanding Line"
    }, {
      name: "create-keypoints",
      helperText: "Add Keypoints (Pose)"
    }, state.fullImageSegmentationMode && {
      name: "show-mask",
      alwaysShowing: true,
      helperText: "Show / Hide Mask"
    }, {
      name: "modify-allowed-area",
      helperText: "Modify Allowed Area"
    }].filter(Boolean).filter(function (a) {
      return a.alwaysShowing || state.enabledTools.includes(a.name);
    }),
    rightSidebarItems: [debugModeOn && React.createElement(DebugBox, {
      key: 1,
      state: debugModeOn,
      lastAction: state.lastAction
    }), // state.taskDescription && (
    //   <TaskDescription
    //     description={state.taskDescription}
    //     state={state}
    //     dispatch={dispatchToReducer}
    //   />
    // ),
    // state.regionClsList && (
    //   <ClassSelectionMenu
    //     selectedCls={state.selectedCls}
    //     regionClsList={state.regionClsList}
    //     onSelectCls={action("SELECT_CLASSIFICATION", "cls")}
    //   />
    // ),
    // state.labelImages && (
    //   <TagsSidebarBox
    //     currentImage={activeImage}
    //     imageClsList={state.imageClsList}
    //     imageTagList={state.imageTagList}
    //     onChangeImage={action("CHANGE_IMAGE", "delta")}
    //     expandedByDefault
    //   />
    // ),
    // (state.images?.length || 0) > 1 && (
    //   <ImageSelector
    //     onSelect={action("SELECT_REGION", "region")}
    //     images={state.images}
    //   />
    // ),
    React.createElement(RegionSelector, {
      key: 2,
      state: state,
      dispatch: dispatchToReducer,
      regions: activeImage ? activeImage.regions : emptyArr,
      onSelectRegion: action("SELECT_REGION", "region"),
      onDeleteRegion: action("DELETE_REGION", "region"),
      onChangeRegion: action("CHANGE_REGION", "region"),
      onChangeLabels: onChangeLabels,
      isVideo: isVideo
    }), state.keyframes && React.createElement(KeyframesSelector, {
      key: 3,
      onChangeVideoTime: action("CHANGE_VIDEO_TIME", "newTime"),
      onDeleteKeyframe: action("DELETE_KEYFRAME", "time"),
      onChangeCurrentTime: action("CHANGE_VIDEO_TIME", "newTime"),
      currentTime: state.currentVideoTime,
      duration: state.videoDuration,
      keyframes: state.keyframes
    })].filter(Boolean)
  }, canvas), React.createElement(SettingsDialog, {
    open: state.settingsOpen,
    onClose: function onClose() {
      return dispatch({
        type: "HEADER_BUTTON_CLICKED",
        buttonName: "Settings"
      });
    }
  })));
};
export default MainLayout;