import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React, { useRef } from "react";
import Paper from "@mui/material/Paper";
import { makeStyles } from "@mui/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import styles from "./styles";
import classnames from "classnames";
import CheckIcon from "@mui/icons-material/Check";
import { Button, TextField } from "@mui/material";
import TrashIcon from "@mui/icons-material/Delete";
import IconButton from "@mui/material/IconButton";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
export var ReviewerComments = function ReviewerComments(_ref) {
  var index = _ref.index,
      onOpen = _ref.onOpen,
      _onChange = _ref.onChange,
      onClose = _ref.onClose,
      onDelete = _ref.onDelete,
      activeComment = _ref.activeComment,
      reviewerComments = _ref.reviewerComments;
  var classes = useStyles();
  var commentInputRef = useRef(null); // eslint-disable-next-line

  var onCommentInputClick = function onCommentInputClick(_) {
    // The TextField wraps the <input> tag with two divs
    var commentInput = commentInputRef.current.children[0].children[0];
    if (commentInput) return commentInput.focus();
  };

  return React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement(Paper, {
    onClick: function onClick() {
      return !activeComment.editing ? !reviewerComments.find(function (comment) {
        return comment.editing;
      }) ? onOpen(_objectSpread({}, activeComment, {
        editing: true,
        highlighted: true
      })) : null : null;
    },
    className: classnames(classes.regionInfo, {
      highlighted: activeComment.highlighted
    })
  }, !activeComment.editing ? React.createElement(React.Fragment, null, React.createElement("div", {
    className: "name",
    style: {
      fontFamily: "Quicksand"
    }
  }, React.createElement("div", {
    className: "circle",
    style: {
      backgroundColor: "red"
    }
  }), index)) : React.createElement("div", {
    style: {
      width: 200
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      flexDirection: "row",
      marginBottom: 4
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      backgroundColor: "red",
      color: "#fff",
      padding: 4,
      paddingLeft: 8,
      paddingRight: 8,
      borderRadius: 4,
      fontWeight: "bold",
      textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
    }
  }, "Reviewer Comment"), React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(IconButton, {
    onClick: function onClick() {
      return onDelete(activeComment);
    },
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, React.createElement(TrashIcon, {
    style: {
      marginTop: -8,
      width: 16,
      height: 16
    }
  }))), activeComment && React.createElement(TextField, {
    InputProps: {
      className: classes.commentBox
    },
    fullWidth: true,
    multiline: true,
    rows: 3,
    ref: commentInputRef,
    onClick: onCommentInputClick,
    value: activeComment.comment,
    onChange: function onChange(event) {
      return _onChange(_objectSpread({}, activeComment, {
        comment: event.target.value
      }));
    },
    placeholder: "Comment..."
  }), onClose && React.createElement("div", {
    style: {
      marginTop: 4,
      display: "flex"
    }
  }, React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(Button, {
    onClick: function onClick() {
      return onClose(_objectSpread({}, activeComment, {
        highlighted: false,
        editing: false
      }));
    },
    size: "small",
    variant: "contained",
    color: "primary"
  }, React.createElement(CheckIcon, null))))));
};
export default ReviewerComments;